\ Analoog naar digitaal omzetting met de TLC549IP: 261/235 bytes.

89C2051  TARGET                         \ Compileer voor AT89C2051
$90 SFR LEDS                            \ Poort 1 met 8 leds

$B3 BIT-SFR ADC-KLOK                    \ Klokpuls invoer P3.4
$B4 BIT-SFR ADC-DATA                    \ Data uitvoer P3.5
$B5 BIT-SFR ADC-SELECTEER               \ Activeer invoer P3.7

: ADC               ( -- u )            \ Doe een AD-omzetting
    CLEAR ADC-KLOK                      \ Stop lezen van analoge invoer
    SET ADC-SELECTEER                   \ Start AD-omzetting
    4 0 DO  LOOP                        \ Conversie duurt min. 17 us 
    CLEAR ADC-SELECTEER                 \ Start uitlezen
    ADC-DATA 1 AND                      \ Lees databit 7
    7 0 DO                              \ Lees resterende 7 databits
        SET ADC-KLOK
        CLEAR ADC-KLOK                  \ Schuif volgend bit naar buiten
        2*  ADC-DATA  1 AND  OR         \ Schaal data in, lees volgend bit
    LOOP
    SET ADC-KLOK                        \ Blijf analoge invoer lezen
    ;

: NAAR-LEDS     ( u -- )                \ Print data binair
    INVERT TO LEDS
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    -1 NAAR-LEDS  250 MS
    0 NAAR-LEDS   250 MS
    ;

: BEELD-AF      ( u -- )                \ Toon met VU- of thermometerschaal
    0 32 UM/MOD                         \ Schaal waarde in voor 8 leds
    SWAP 15 > IF  1+  THEN              \ Rond af naar hogere waarde
    DUP IF                              \ Uitkomst groter dan nul ?
        1 SWAP 1- LSHIFT                \ Ja, bepaal positie van led
\       DUP 1-  OR                      \ Vul leds daaronder in
    THEN
    NAAR-LEDS                           \ Stuur leds aan
    ;
 
: TOON-ADC      ( -- )                  \ Toon AD-omzetting op LEDS
    SETUP                               \ Installeer Forth stacks
    KNIPPER
    ADC DROP                            \ Eerste AD-omzetting is ongeldig
    BEGIN
        ADC  BEELD-AF                   \ Lees ADC, en toon uitkomst
    AGAIN
    ;

' TOON-ADC   RESET-VEC  SET-VECTOR      \ TOON-ADC start op na een reset

\ Einde
