\ RS232 in- en uitvoer met, als extra uitvoer naar LEDS: 329/301 bytes.

89C2051  TARGET                         \ Compileer voor AT89C2051
needs target.frt
$90 SFR LEDS                            \ Poort 1 met 8 leds
$99 BIT-SFR EMIT?                       \ RS232 zend buffer leeg ?
$98 BIT-SFR KEY?                        \ RS232 ontvang buffer vol ?
$8E BIT-SFR TIMER1                      \ Timer 1 start/stop
$AC BIT-SFR RS232-INTERRUPT             \ RS232 interrupt aan/uit
ASSEMBLER                               \ Gebruik assembler labels
TMOD: SFR TIMER-MODE                    \ Timer instelling
PCON: SFR POWER-MODE                    \ RS232 snelheid verdubbeling
SCON: SFR RS232-MODE                    \ RS232 instelling
TH1:  SFR TIMER1-HIGH                   \ Hoge byte van timer 1
SBUF: SFR RS232-BUFFER                  \ RS232 in/uitvoer buffer
WORK

: RS232-SETUP       ( -- )
    TIMER-MODE  $20 OR  TO TIMER-MODE   \ Timer-1 mode 2 = 8 bit autoreload
    243 TO TIMER1-HIGH                  \ Selecteer 1200/2400 baud
    TRUE TO TIMER1                      \ Start timer 1
    POWER-MODE  $80 OR  TO POWER-MODE   \ Verdubbel RS232 ( 2400 baud )
    $52 TO RS232-MODE                   \ Seriele mode 1, ontvangst aan
                                        \ Zet zend interrupt vlag
    FALSE TO RS232-INTERRUPT            \ Zet RS232 interrupt uit
    ;

: EMIT              ( char -- )         \ Stuur karakter via RS232
    BEGIN  EMIT? UNTIL                  \ Wacht tot karakter verzonden is
    TO RS232-BUFFER                     \ Verzend karakter
    FALSE TO EMIT?                      \ Geef aan dat de buffer gevuld is
    ;

: TYPE              ( $addr u -- )      \ Stuur ROM string via RS232
    ?DUP IF                             \ Druk de string alleen af als
        0 DO                            \ u groter dan nul is
            COUNT EMIT
        LOOP
    THEN
    2DROP                               \ Verwijder string adres
    ;

: KEY               ( -- char )         \ Ontvang karakter via RS232
    BEGIN  KEY? UNTIL                   \ Wacht tot karakter ontvangen is
    RS232-BUFFER                        \ Lees karakter
    FALSE TO KEY?                       \ Geef aan dat de buffer gelezen is
    ;

\ Een klein RS232 tekst in- uitvoer voorbeeld

ATOM INLINE$        ( -- $addr u )      \ Importeer string literal macro

: CR        ^M EMIT  ^J EMIT ;          \ Nieuwe regel
: PAGE      ^L EMIT ;                   \ Maak beeldscherm schoon

: NAAR-LEDS         ( x -- )            \ Toon data op LEDS
    INVERT TO LEDS
    ;

: BEHANDEL-INVOER   ( -- )              \ Handel karakter invoer af
    BEGIN
        CR ." > " KEY  DUP NAAR-LEDS    \ Copieer karakter op LEDS
        DUP &A = IF  ." Aap "   THEN    \ Verzend "Aap" via RS232, etc.
        DUP &B = IF  ." Boef "  THEN
        DUP &C = IF  ." Chip "  THEN
    &Q = UNTIL
    ;

: TEKST-I/O         ( -- )              \ RS232 tekst in- uitvoer proef
    SETUP
    RS232-SETUP
    BEGIN
        PAGE ." RS232 I/O proef voor AT51 printje"
        BEHANDEL-INVOER
    AGAIN
    ;

' TEKST-I/O     RESET-VEC  SET-VECTOR   \ TEKST-I/O start op na een reset

\ Einde