\ Een motor vermogensregeling via Puls Breedte Modulatie, 135/133 bytes

89C2051  TARGET                         \ Compileer voor AT89C2051
NEEDS TARGET.FRT

15 CONSTANT CYCLUS                      \ PBM cyclus lengte
VARIABLE PERIODE                        \ Tel PBM cyclus af
VARIABLE AANPULS                        \ PBM aan tijd
VARIABLE AANTIJD                        \ PBM aan werkregister
$94 BIT-SFR UITGANG                     \ PBM uitgang P1.4

\ De PBM interrupt gebruikt (44*1000)+(8*50)=44400 cycles van
\ de 500.000, dat is minder dan 10 % van de processortijd.
CODE PBM            ( -- )              \ Timer-0: PBM opwekking
    ACC: PUSH,                          \ Bewaar het gebruikte register
    TH0: -500. NIP # MOV,               \ Zet herhalingstijd
    TL0: -500. DROP # MOV,
    A: ADR AANTIJD MOV,                 \ PBM aan tijd verstreken ?
    ZER IF,
        ADR UITGANG CLR,                \ Ja, dan uitgang laag
    ELSE,
        ADR UITGANG SETB,               \ Nee, uitgang hoog en
        ADR AANTIJD DEC,                \ verlaag uitgang hoog teller
    THEN,
    ADR PERIODE DEC,                    \ Verlaag cyclus teller
    A: ADR PERIODE MOV,                 \ PBM cyclus tijd verstreken ?
    ZER IF,
        ADR AANTIJD ADR AANPULS MOV,    \ Ja, herstel uitgang tikken
        ADR PERIODE CYCLUS # MOV,       \ en zet cyclus duur
    THEN,
    ACC: POP,                           \ Herstel het gebruikte register
    RETI,
END-CODE

CODE SETUP-PBM       ( -- )
    TH0: -500. NIP # MOV,               \ Zet de cyclustijd van teller 0
    TL0: -500. DROP # MOV,
    ADR PERIODE CYCLUS # MOV,           \ Zet periode tijd van een PBM cyclus
    ADR AANTIJD 0 # MOV,                \ PBM puls is nul
    ADR AANPULS 0 # MOV,
    ADR UITGANG CLR,                    \ PBM uitgang staat uit
    TMOD: $01 # MOV,                    \ Zet Timer 0 in mode 1
    IE: .1 SETB,                        \ Sta timer 0 interrupts toe
    TCON: .4 SETB,                      \ Start timer 0
    IE: .7 SETB,                        \ Zet interrupt mechanisme aan
    RET,
END-CODE

: ZET-PULSBREEDTE   ( -- )              \ Zet nieuwe pulsbreedte
    CYCLUS UMIN TO AANPULS
    ;

\ Motor regeling demonstratie

$B0 SFR INGANG                          \ Ingang met de schakelaars P3.0-P3.3

: ZET-SNELHEID      ( -- u )            \ Lees schakelaar en inverteer
    INGANG INVERT  $F AND               \ het resultaat, laagste 4 bits zijn
    ZET-PULSBREEDTE                     \ geldig. Zet de motorsnelheid.
    ;

: REGEL-MOTOR       ( -- )              \ Regel een gelijkstroom motor
    SETUP   SETUP-PBM
    BEGIN  ZET-SNELHEID  AGAIN
    ;

' PBM           TF0-VEC     SET-VECTOR  \ Installeer de PBM interrupt
' REGEL-MOTOR   RESET-VEC   SET-VECTOR  \ REGEL-MOTOR start op na een reset
