\ Besturing van twee servo's, 245/235 bytes.

89C2051                                 \ Compileer voor AT80C2051
NEEDS TARGET.FRT

$89  SFR TMOD                           \ Timer 0 werkings-mode
$8C  SFR TH0                            \ Timer 0 registers
$8A  SFR TL0
$A9  BIT-SFR ET0                        \ Timer 0 interrupt aan/uit bit
$8C  BIT-SFR TR0                        \ Timer 0 start/stop bit
$AF  BIT-SFR EAL                        \ Interrupt mechanisme aan/uit

VARIABLE STAND                          \ Toestand van de servo interrupt
2 2VARIABLES SERVOS                     \ Pulslengte van beide servos

: SERVO         ( u s -- )              \ Zet nieuwe stand u van servo s
    >R  1  D2*  DNEGATE  R> TO SERVOS   \ Converteer u naar timer waarde
    ;                                   \ voor servo s

\ Een servo routine op interrupts

CODE SERVO-INTERRUPT ( -- )             \ Aansturing voor 2 servo's
    ACC: PUSH,
    A: ADR STAND MOV,                   \ Geef interrupt toestand
    ZER IF,                             \ Is die nul ?
        P3: .4 SETB,                    \ Puls op uitgang P3.4
        ADR TH0  0 SERVOS MOV,          \ Zet pulsbreedte voor servo 0
        ADR TL0  0 SERVOS LOW MOV,
        ADR STAND INC,                  \ Naar volgende toestand
        ACC: POP,
        RETI,
    THEN,  
    A: DEC,                             \ De interrupt toestand is 1
    ZER IF,                             \ Is die nul ?
        P3: .4 CLR,                     \ Stop puls op uitgang P3.4
        P3: .5 SETB,                    \ Puls op uitgang P3.5
        ADR TH0  1 SERVOS MOV,          \ Zet pulsbreedte voor servo 1
        ADR TL0  1 SERVOS LOW MOV,
        ADR STAND INC,                  \ Naar volgende toestand
        ACC: POP,
        RETI,
    THEN,                               \ De interrupt toestand is 2
    P3: .5 CLR,                         \ Stop puls op uitgang P3.5
    ADR TH0  -10000. NIP # MOV,         \ Zet 20 millisec. pauze puls
    ADR TL0  -10000. DROP # MOV,
    ADR STAND 0 # MOV,                  \ Begin weer in toestand 0
    ACC: POP,
    RETI,
END-CODE

: SETUP-SERVO       ( -- )              \ Zet hardware voor servo aansturing
    CLEAR STAND                         \ Begin in toestand 0
    $01 TO TMOD                         \ Zet timer 0 in mode 1
    SET TH0  SET TL0                    \ Zet timer register
    SET ET0                             \ Sta timer interrupt toe
    SET TR0                             \ Activeer timer 0
    SET EAL                             \ Zet interrupt mechaniek aan
    ;

\ Demonstratie programma met twee servo's

: 100MS         ( u -- )                \ Wacht u maal 100 millisec.
    FOR  100 MS  NEXT
    ;

: BEWEEG-SERVOS ( -- )
    SETUP  SETUP-SERVO                  \ Initialiseer stacks en servo hardware
    BEGIN                               \ Start servo demo
        25 0 DO
            I 10 * 0 SERVO              \ Zet servo 0, dan
            25 I - 10 * 1 SERVO 3 100MS \ servo 1 en wacht even
        LOOP
        20 100MS
    AGAIN
    ;

' SERVO-INTERRUPT TF0-VEC   SET-VECTOR  \ Installeer timer 0 interrupt
' BEWEEG-SERVOS   RESET-VEC SET-VECTOR  \ BEWEEG-SERVOS start op na een reset