\ Unipolaire vierfase stappenmotor sturing, 205 bytes.

89C2051  TARGET                         \ Compileer voor AT89C2051

$90 SFR MOTOR                           \ Stappenmotor uitgang P1.4 - P1.7
$B0 SFR INGANG                          \ Schakelaar ingang P3.0 - P3.2
$B3 BIT-SFR RICHTING?                   \ Vooruit/achteruit selectie P3.3

VARIABLE STAP                           \ Volgend uitgangs woord
VARIABLE STAP#                          \ Tabel masker

$80 $40 $20 $10                  4 CONSTANTS 1FASE  \ Enkelfase aansturing  ( n -- x )
$90 $C0 $60 $30                  4 CONSTANTS 2FASE  \ Dubbelfase aansturing ( n -- x )
$90 $80 $C0 $40 $60 $20 $30 $10  8 CONSTANTS HALF   \ Halvestap aansturing  ( n -- x )

: EEN-FASE   FROM STAP 1FASE TO MOTOR  3 TO STAP# ;
: TWEE-FASE  FROM STAP 2FASE TO MOTOR  3 TO STAP# ;
: HALF-STAP  FROM STAP HALF  TO MOTOR  7 TO STAP# ;

: WACHT         ( -- )                  \ Wacht 20 of 40 milliseconden
    INGANG INVERT 1 AND  1+  20 * MS
    ;

: EEN-STAP      ( -- )
    INGANG INVERT $06 AND               \ Lees sturing type bits
    BEGIN-SELECT                        \ en selecteer sturing
        SELECT $02  EEN-FASE    EXIT    \ Sturing via eenfase
        SELECT $04  TWEE-FASE   EXIT    \ Sturing via tweefase
        SELECT $06  HALF-STAP   EXIT    \ Sturing via halfstap
                    CLEAR MOTOR         \ Geen motor sturing
    END-SELECT
    ;

: VOORUIT       ( -- )                  \ Motor een stap vooruit
    FROM STAP 1+  FROM STAP# AND  TO STAP
    EEN-STAP  WACHT
    ;

: ACHTERUIT     ( -- )                  \ Motor een stap achteruit
    FROM STAP 1-  FROM STAP# AND  TO STAP
    EEN-STAP  WACHT
    ;

: SETUP-STAP    ( -- )
    3 TO STAP#                          \ Zet default tabel masker
    CLEAR STAP                          \ Begin bij de eerste stap
    ;

: BEWEEG        ( -- )                  \ Kies draairichting van de motor
    RICHTING? IF  VOORUIT  ELSE  ACHTERUIT  THEN
    ;

: STAP-MAAR     ( -- )                  \ Bestuur een 4 fase stappenmotor
    SETUP  SETUP-STAP
    BEGIN  BEWEEG  AGAIN
    ;

' STAP-MAAR     RESET-VEC   SET-VECTOR  \ STAP-MAAR start op na een reset