\ RC5 zender voor 6 MHz kristal, 154/146 bytes.

89C2051  TARGET                         \ Compileer voor AT89C2051

$B7 BIT-SFR UITGANG                     \ RC5 uitgangs bit
$B3 BIT-SFR INGANG                      \ RC5 Schakelaar ingang
$B2 BIT-SFR LED                         \ RC5 Led uitgang
$E0 CONSTANT RC-TYPE                    \ RC5 Zender type (hier TV)

CODE HALVE-BIT      ( -- )              \ Wacht 878 us
    R1: 2 # MOV,
    DO,
        R2: 107 # MOV,
        DO,  R2: LOOP,
    R1: LOOP,
    RET,
END-CODE

: EEN               ( -- )              \ Zend hoog bit 1768 us
    CLEAR UITGANG                       \ 4 us
    HALVE-BIT                           \ 878 us
    SET UITGANG                         \ 4 us
    HALVE-BIT                           \ 878 us
    ;                                   \ 4 us

: NUL               ( -- )              \ Zend laag bit 1752 us
    SET UITGANG
    HALVE-BIT
    CLEAR UITGANG
    HALVE-BIT
    ;

CODE ZEND-RC        ( -- )              \ Zend R3 bits uit de accu R3 * 1786/1782 us
    DO,
        A: RLC,                         \ 2 us
        CS IF,                          \ 4 us
            ' EEN CALL,                 \ 1768
        ELSE,                           \ 4 us
            ' NUL CALL,                 \ 1768 us
        THEN,
    R3: LOOP,                           \ 4 us
    RET,                                \ 8 us
END-CODE

CODE RC-EMIT        ( x -- )            \ Zend 'x' naar een tv of videorec.
    A: @R0 MOV,                         \ Pak het commando
    A: RL,                              \ Sla twee hoge bits over
    A: RL,
    R4: A: MOV,                         \ Bewaar commando
    R0: INC,
    A: RC-TYPE # MOV,                   \ Systeem data (zender type)
    R3: 8 # MOV,                        \ Zend ook de start bits
    ' ZEND-RC CALL,                     \ (1786 us * 8) + 8 
    A: R4: MOV,
    R3: 6 # MOV,                        \ Zend een 6 bit RC5 commando
    ' ZEND-RC CALL,                     \ (1786 us * 6) + 8 + 10
    ADR UITGANG CLR,                    \ Zet 36 KHz osc uit.
    RET,                                \ 8 us
END-CODE

: 10MS              ( u -- )            \ Wacht u maal 10 millisec.
    FOR  10 MS  NEXT
    ;

: FLITS             ( -- )              \ Laat LED flitsen
    CLEAR LED  50 10MS
    SET LED    50 10MS
    ;

: RC-ZENDER         ( -- )              \ Zend een RC start code
    SETUP  CLEAR UITGANG                \ Uitgang uit
    BEGIN
        FLITS                           \ Toon activatie
        BEGIN  INGANG 0= UNTIL          \ Wacht op toetsaanslag
        12 RC-EMIT                      \ Zend aan/uit code
    AGAIN
    ;

' RC-ZENDER  RESET-VEC  SET-VECTOR      \ RC-ZENDER start op na een reset