\ LC-beeldscherm uitvoer met vier databits, 422/413 bytes.

89C2051  TARGET                         \ Compileer voor AT89C2051
ATOM MS                                 \ Importeer MS
40 CONSTANT B/L                         \ Display regelbuffer lengte
16 CONSTANT C/L                         \ Regel lengte van LC-display
2 CONSTANT L/S                          \ Regels per LC-display
VARIABLE UIT                            \ Huidige cursor positie
FLAG DATA?                              \ LC data type, true is een karakter
ASSEMBLER  P1: SFR POORT                \ I/O poort met het LC-display
P1: .4 BIT-SFR GELDIG                   \ Data geldig bit
P1: .5 BIT-SFR SELECTEER                \ Data is karakter of instructie bit
P3: .0 BIT-SFR LED                      \ Opstart indicatie led
P3: .7 BIT-SFR MASSA  WORK              \ Massa aansluiting voor lcd

: >LCD          ( nibble -- )
    $F AND TO POORT  DATA? TO SELECTEER \ Stuur nibble op, karakter of data
    SET GELDIG  CLEAR GELDIG            \ Zet data op LC-display
    ;

: LCD-CHAR      ( kar -- )              \ Stuur kar naar LC-display
    SPLIT  >LCD  >LCD
    ;

: LCD-INSTR     ( byte -- )             \ Stuur data naar LC-display
    CLEAR DATA?  LCD-CHAR  SET DATA?
    ;

: LCD-PAGE      ( -- )                  \ Maak LC-display schoon en zet de
    1 LCD-INSTR  CLEAR UIT  2 MS        \ cursor in linker bovenhoek.
    ;

: LCD-SETUP     ( -- )
    CLEAR DATA?  16 MS                  \ Naar instructie mode, wacht en
    3 FOR  %0011 >LCD  5 MS  NEXT       \ zet 8 bits interface mode
    %0010 >LCD                          \ zet tenslotte 4 bits interface mode.
    $28 LCD-INSTR                       \ 4 bits interf. 2 regel displ, 5*7 bits kar.
    $08 LCD-INSTR  LCD-PAGE             \ Display uit, en schoon
    $06 LCD-INSTR                       \ Display richting naar rechts
    $0C LCD-INSTR                       \ Display aan & cursor uit
    ;

: LCD-EMIT      ( kar -- )              \ Stuur een char naar een LC-display.
    INCR UIT  LCD-CHAR
    ;

: LCD-TYPE      ( $addr u -- )          \ Stuur u karakters vanaf het ROM adres
    FOR  COUNT LCD-EMIT  NEXT  2DROP    \ $addr naar een LC-display.
    ;

: LCD-SPACE     ( -- )                  \ Stuur een spatie naar een LC-display.
    BL LCD-EMIT
    ;

: LCD-SPACES    ( u -- )                \ Stuur u spaties naar een LC-display.
    FOR  LCD-SPACE  NEXT
    ;

: LCD-CR        ( -- )                  \ Stuur CR naar een LC-display.
    C/L  FROM UIT  - 0< IF              \ Staat cursor op regel 2 ?
        $80 LCD-INSTR  CLEAR UIT        \ Ja, naar regel 1
    ELSE
        $C0 LCD-INSTR  C/L TO UIT       \ Nee, naar regel 2
    THEN
    ;

\ Het LCD voorbeeld

ATOM INLINE$                            \ Maak ." bruikbaar"
: TYPE      LCD-TYPE ;
: 100MS     FOR 100 MS NEXT ; ( u -- )  \ Wacht u maal 100 millisec.

: REGEL-VOL?    ( -- )                  \ Ga naar volgende regel, indien nodig
    FROM UIT 16 =                       \ Regel 1 of regel 2
    FROM UIT 32 =  OR IF                \ gevuld ?
        LCD-CR                          \ Ja, naar andere regel
    THEN
    ;

: LCD-DEMO      ( n -- )                \ Een voorbeeld met een LC-display.
    SETUP  CLEAR MASSA  CLEAR LED
    100 MS  SET LED  LCD-SETUP
    BEGIN
        ."  'Egel LCD demo"  LCD-CR     \ 'Egel melding
        ."   (C) Forth-gg"
        30 100MS  LCD-PAGE              \ Wacht en maak scherm schoon
        0 0 DO                          \ Toon hele karakterset
            I LCD-EMIT  100 MS
            REGEL-VOL?                  \ Ga naar nieuwe regel, indien nodig
        LOOP
        10 100MS  LCD-PAGE              \ Wacht en maak scherm schoon
    AGAIN
    ;   

' LCD-DEMO      RESET-VEC  SET-VECTOR   \ LCD-DEMO start op na een reset
