\ I2C uitvoer met een PCF8574 (234/213 bytes).

89C2051 TARGET                          \ Code draait op een 89C2051
needs target.frt

\ I2C primitieven voor een 6 MHz kristal

ASSEMBLER
P3: .4  BIT-SFR SDA                     \ Serieele data lijn
P3: .5  BIT-SFR SCL                     \ Serieele klok lijn
WORK
$40 CONSTANT I/O-ID                     \ Device adres 0 van gebruikte chip

\ Algemene I2C primitieven

: SETUP-I2C      ( -- )                 \ Setup I2C I/O bits
    SET SDA  SET SCL
    ;

: START-BIT     ( -- )                  \ Genereer startbit
    SET SDA  SET SCL  CLEAR SDA  CLEAR SCL
    ;

: STOP-BIT      ( -- )                  \ Genereer stopbit
    CLEAR SDA  SET SCL  SET SDA
    ;

: ACK?          ( -- vlag )             \ Test binnenkomend ackbit, vlag is
    SET SDA  SET SCL  SDA 0=  CLEAR SCL \ true als er een ack ontvangen is
    ;

: BYTE-UIT      ( byte -- )             \ Stuur byte en test ack
    8 FOR
        DUP 128 AND  TO SDA  2*
        SET SCL  CLEAR SCL
    NEXT
    DROP  ACK? 0= IF  STOP-BIT  THEN    \ Geen ack, genereer dan een stopbit
    ;

\ Uitvoer routine voor PCF8574(a) chips

: !BYTE         ( byte chip -- )
    START-BIT
    $FE AND BYTE-UIT                    \ Stuur schrijfadres naar chip en
    BYTE-UIT                            \ daarna de databyte
    STOP-BIT                            \ Klaar
    ;

\ Onze eerste I2C toepassing een looplicht

: NAAR-LEDS     ( byte -- )             \ Stuur data naar PCF8574 op adres 0
    INVERT  $0F OR  I/O-ID !BYTE        \ De lage 4 bits zijn altijd hoog
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    255 NAAR-LEDS  250 MS
    0   NAAR-LEDS  250 MS
    ;

: LOOPLICHT     ( -- )                  \ Toon een looplicht op de leds
    SETUP  SETUP-I2C  KNIPPER
    BEGIN
        4 0 DO
            1 I 4 + LSHIFT NAAR-LEDS    \ Zet een led aan
            100 MS                      \ Wacht 100 millisec.
        LOOP
    AGAIN
    ;

' LOOPLICHT     RESET-VEC   SET-VECTOR  \ LOOPLICHT start op na een reset
