\ ==============================================================
\ [TITLE]     AT89Cx051 ByteForth demo code
\ [FILE]      LED.FRT
\ [CATEGORY]  Demo, 125 bytes, opt: 105 bytes
\ [VSN]       1.00 
\ [CREATED]   September 21, 1995, Willem Ouwerkerk
\ [LASTCHNGD] September 21, 1995, Willem Ouwerkerk
\ [COPYRIGHT] Elektrise Schaar (C) 1995
\ [USES]      ByteForth cross compiler
\ [PURPOSE]   Demo for ByteForth cross compiler.
\ ==============================================================

89C1051 TARGET                  ( Target compilatie )

$90 BIT-SFR LAMP                ( Bit met een led daarop ) 
$91 BIT-SFR AAN/UIT?            ( Aan uit schakelaar voor led )
$92 BIT-SFR FLITSDUUR?          ( Flits periode tijd voor led )
VARIABLE WACHTTIJD              ( Onthoud periode tijd )
    
ATOM MS                         ( Importeer 6 MHz millisec. )
    
: 10MS      ?DUP IF  FOR  10 MS  NEXT  THEN ;  ( u -- )
: WACHT     FROM WACHTTIJD 10MS ;  ( -- )

: ZET-WACHTTIJD ( -- )          ( Zet periode tijd op 200 of 800 ms )
    80
    FLITSDUUR?
    IF
        60 -
    THEN
    TO WACHTTIJD
    ;
    
: FLITS     ( -- )              ( Hoofdprogramma )
    SETUP                       ( Initialiseer de Forth machine )
    SET LAMP                    ( Zet de led uit )
    SET AAN/UIT?                ( Invoerbits moeten hoog zijn )
    SET FLITSDUUR?
    BEGIN
        BEGIN
            ZET-WACHTTIJD       ( Zet de periode tijd )
            AAN/UIT?            ( Schakelaar aan ? )
        WHILE
            CLEAR LAMP WACHT    ( Ja, laat led flitsen )
            SET LAMP   WACHT
        REPEAT
    AGAIN                       ( Eindeloze lus )
    ;

' FLITS  RESET-VEC  SET-VECTOR  ( Installeer start vector )

\ End
