\ ==============================================================
\ [TITLE]     AT89Cx051 ByteForth single number BCD library. 
\ [FILE]      BCD.FRT
\ [CATEGORY]  Library ( 25 bytes )
\ [VSN]       1.00
\ [CREATED]   June 14, 2001, Willem Ouwerkerk 
\ [LASTCHNGD] June 14, 2001, Willem Ouwerkerk 
\ [COPYRIGHT] De Elektrise Schaar (C) 2001-
\ [USES]      ByteForth cross compiler
\ [PURPOSE]   BCD conversion primitives
\ ==============================================================

NEEDS TARGET.FRT

\G Converteer binair getal +n1 naar BCD getal +n2 (10).
CODE >BCD       ( +n1 -- +n2 )          \ Bcd  "to-bcd"
    A: @R0 MOV,
    B: 10 # MOV,
    AB: DIV,
    A: SWAP,
    A: B: ORL,
    @R0 A: MOV,
    RET,
END-CODE

\G Converteer BCD getal +n1 naar binair getal +n2 (15).
CODE BCD>       ( +n1 -- +n2 )          \ Bcd  "bcd-from"
    A: @R0 MOV,
    A: $0F # ANL,
    R1: A: MOV,     ( low part in R1 )
    A: @R0 MOV,
    A: SWAP,
    A: $0F # ANL,   ( high part in accu )
    B: 10 # MOV,    ( conversion number in B )
    AB: MUL,
    A: R1: ADD,     ( add binary results )
    @R0 A: MOV,
    RET,
END-CODE

\ Einde
