\ I2C primitieven voor een 6 MHz kristal (133 bytes)

P3: .4  BIT-SFR SDA                     \ Serieele data lijn
P3: .5  BIT-SFR SCL                     \ Serieele klok lijn

\ Algemene I2C primitieve routines

\G Initialiseer de I2C bus.
: SETUP-I2C      ( -- )                 \ I2C-Prim  Setup I2C I/O bits
    SET SDA  SET SCL
    ;

\G Genereer een I2C startbit.
: START-BIT     ( -- )                  \ I2C-Prim  Genereer startbit
    SET SDA  SET SCL  CLEAR SDA  CLEAR SCL
    ;

\G Genereer een I2C stopbit.
: STOP-BIT      ( -- )                  \ I2C-Prim  Genereer stopbit
    CLEAR SDA  SET SCL  SET SDA
    ;

\G Genereer een I2C negative acknowledge.
: NACK-BIT      ( -- )                  \ I2C-Prim  Genereer no-ackbit
    SET SDA  SET SCL  CLEAR SCL
    ;

\G Genereer een I2C acknowledge.
: ACK-BIT       ( -- )                  \ I2C-Prim  Genereer ackbit
    CLEAR SDA  SET SCL  CLEAR SCL  SET SDA
    ;

\G Test het inkomende bit. Geef true als het een acknowledge is
\G en anders false.
: ACK?          ( -- vlag )             \ I2C-Prim  Test binnenkomend ackbit, vlag is
    SET SDA  SET SCL  SDA 0=  CLEAR SCL \ true als er een ack ontvangen is
    ;

\G Zend byte x via de I2C bus.
: (BYTE-UIT)    ( x -- )                \ I2C-Prim  Stuur byte
    8 FOR
        DUP 128 AND  TO SDA  2*
        SET SCL  CLEAR SCL
    NEXT
    DROP
    ;

\G Zend byte x via de I2C bus en genereer een stopbit als het
\G geadresseerde device niet reageert met een acknowledge.
: BYTE-UIT      ( x -- )                \ I2C-Prim  Stuur byte en test ack
    (BYTE-UIT)  ACK? 0= IF  STOP-BIT  THEN
    ;

\G Ontvang byte x via de I2C bus.
: BYTE-IN       ( -- x )                \ I2C-Prim  Ontvang byte
    0  8 FOR
        SET SCL  2*  SDA 1 AND  OR  
        CLEAR SCL
    NEXT
    ;

\G De vlag is true als het device geadresseerd met dev-id aanwezig
\G is op de I2C bus en anders is hij false.
: AANWEZIG?     ( dev-id -- vlag )      \ I2C-Prim  De vlag is true als dev-id aanwezig is
    START-BIT  (BYTE-UIT)  ACK?  STOP-BIT
    ;

\ Einde