\ I2C routines om in een 24C65 EEPROM te lezen en schrijven (46 bytes) = 7,95
\ Deze code is ook geschikt voor de 24C32, 24C64, 24C128 en 24C256
\ Heeft I2C-PRIM.FRT nodig uit de bibliotheek ( LIB ).

$A0 CONSTANT EEPROM-ID                  \ EEPROM identificatie adres

\G Lees de data x vanaf het dubbele EEPROM adres addr. Deze ByteForth
\G library is ook bruikbaar voor de: 24C32, 24C64, 24C128 en de 24C256.
: LEES-BYTE     ( addr -- x )           \ I2C24C65 Lees x uit d-adres in EEPROM
    START-BIT
    EEPROM-ID BYTE-UIT                  \ Stuur chip adres voor schrijven
    BYTE-UIT                            \ Stuur EEPROM leesadres hoog
    BYTE-UIT                            \ Stuur EEPROM leesadres laag
    START-BIT                           \ Geef herhaalde start conditie
    EEPROM-ID 1+ BYTE-UIT               \ Stuur chip adres voor het lezen
    BYTE-IN             NACK-BIT        \ van data uit het EEPROM adres
    STOP-BIT
    ;

\G Schrijf de data x naar het dubbele EEPROM adres addr. ByteForth deze
\G library is ook bruikbaar voor de: 24C32, 24C64, 24C128 en de 24C256.
: SCHRIJF-BYTE  ( x addr -- )           \ I2C24C65 Schrijf x naar d-adres in EEPROM
    BEGIN
        START-BIT  EEPROM-ID (BYTE-UIT)
    ACK? UNTIL                          \ Wacht op ackbit
    BYTE-UIT BYTE-UIT BYTE-UIT STOP-BIT \ Stuur d-adres en databyte
    ;

\ Einde