\ ==============================================================
\ [TITLE]     AT89Cx051 ByteForth MS host & target library. 
\ [FILE]      RS232.FRT
\ [CATEGORY]  Library ( 11/14 bytes )
\ [VSN]       1.00 
\ [CREATED]   April 30, 1995, Willem Ouwerkerk 
\ [LASTCHNGD] January 24, 1998, Willem Ouwerkerk 
\ [COPYRIGHT] De Elektrise Schaar (C) 1995-1998
\ [USES]      ByteForth cross compiler
\ [PURPOSE]   MS word for different cristal speeds
\             1MHz, 3MHz, 4MHz, 6MHz, 11.059, 12MHz and 24 MHz.
\ ==============================================================

1 CRYSTAL? [IF]

\G Wacht tenminste u milliseconden. Er zijn versies beschikbaar
\G voor frequenties van 1, 3, 4, 6, 11.059, 12, en 24 MHz.
CODE MS             ( u -- )            \ Ms "m-s" Wait for u milliseconds
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 28 # MOV,
            DO,     NOP,
            R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

\G Wacht tenminste u maal 100 microseconden. Er zijn versies 
\G beschikbaar voor freq. van 1, 3, 4, 6, 11.059, 12, en 24 MHz.
CODE /MS            ( u -- )            \ Ms "slash-m-s"
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 1 # MOV,
            DO,  R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

[THEN]

3 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 83 # MOV,
            DO,     NOP,
            R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 12 # MOV,
            DO,  R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

[THEN]

4 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 111 # MOV,
            DO,     NOP,
            R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 16 # MOV,
            DO,  R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

[THEN]

6 CRYSTAL? [IF]                         \ Also present in MACROS.FRT

CODE MS             ( u -- )            \ Wait for u milliseconds
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 166 # MOV,
            DO,     NOP,
            R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 25 # MOV,
            DO,  R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

[THEN]

11 CRYSTAL? [IF]                        \ Baudrate xtal: 11.059 

CODE MS             ( u -- )            \ Wait for u milliseconds
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 153 # MOV,
            DO,     AB: MUL,
            R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 48 # MOV,
            DO,  R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

[THEN]

12 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 166 # MOV,
            DO,     AB: MUL,
            R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 50 # MOV,
            DO,  R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

[THEN]

24 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 166 # MOV,
            DO,     AB: MUL,
                    AB: MUL,
                    NOP, NOP,
            R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    [R1] @R0 MOV,
    R0: INC,
    DO,     R2: 100 # MOV,
            DO,  R2: LOOP,
    R1: LOOP,
    RET,
END-CODE            

[THEN]

\ End
