\ ----------------------------------------------------------------------
\ LANGUAGE    : 8051 ByteForth vsn 2.00
\ PROJECT     : ByteForth, an ANS-like Forth for 8051-derivatives
\ DESCRIPTION : Symbolic register names and interrupt vectors
\ CATEGORY    : Utility Programs
\ AUTHOR      : Willem Ouwerkerk, January 25, 2001
\ LAST CHANGE : Willem Ouwerkerk, December 9, 2001
\ ----------------------------------------------------------------------

DOC  Veel constanten

$88 CONSTANT TCON:      $89 CONSTANT TMOD:
$C8 CONSTANT T2CON:     $98 CONSTANT SCON:
$B8 CONSTANT IP:        $A8 CONSTANT IE:
$87 CONSTANT PCON:      $99 CONSTANT SBUF:
$8A CONSTANT TL0:       $8C CONSTANT TH0:
$8B CONSTANT TL1:       $8D CONSTANT TH1:
$CC CONSTANT TL2:       $CD CONSTANT TH2:
$CA CONSTANT RCAP2L:    $CB CONSTANT RCAP2H:

\ Bitaddresses for the 8051 series

$88 CONSTANT IT0:       $89 CONSTANT IE0:
$8A CONSTANT IT1:       $8B CONSTANT IE1:
$8C CONSTANT TR0:       $8D CONSTANT TF0:
$8E CONSTANT TR1:       $8F CONSTANT TF1:

$90 CONSTANT T2:        $91 CONSTANT T2EX:

$98 CONSTANT RI:        $99 CONSTANT TI: 
$9A CONSTANT RB8:       $9B CONSTANT TB8:
$9C CONSTANT REN:       $9D CONSTANT SM2:
$9E CONSTANT SM1:       $9F CONSTANT SM0:

$A8 CONSTANT EX0:       $A9 CONSTANT ET0:
$AA CONSTANT EX1:       $AB CONSTANT ET1:
$AC CONSTANT ES:        $AF CONSTANT EA: 

$B0 CONSTANT RXD:       $B1 CONSTANT TXD:
$B2 CONSTANT INT0:      $B3 CONSTANT INT1:
$B4 CONSTANT T0:        $B5 CONSTANT T1: 
$B6 CONSTANT WR:        $B7 CONSTANT RD:  

$B8 CONSTANT PX0:       $B9 CONSTANT PT0:
$BA CONSTANT PX1:       $BB CONSTANT PT1:
$BC CONSTANT PS: 

$D0 CONSTANT P:
$D2 CONSTANT OV:        $D3 CONSTANT RS0: 
$D4 CONSTANT RS1:       $D5 CONSTANT F0: 
$D6 CONSTANT AC:        $D7 CONSTANT CY:  

ENDDOC



89C1051? [IF]

$81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $87 CONSTANT PCON:
$88 CONSTANT TCON:      $89 CONSTANT TMOD:
$8A CONSTANT TL0:       $8B CONSTANT TL1:
$8C CONSTANT TH0:       $8D CONSTANT TH1:
$90 CONSTANT P1:        $98 CONSTANT SCON:
$99 CONSTANT SBUF:      $A8 CONSTANT IE:
$B0 CONSTANT P3:        $B8 CONSTANT IP:
$D0 CONSTANT PSW:       $E0 CONSTANT ACC:
$F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL

[THEN]


89C2051? [IF]

$81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $87 CONSTANT PCON:
$88 CONSTANT TCON:      $89 CONSTANT TMOD:
$8A CONSTANT TL0:       $8B CONSTANT TL1:
$8C CONSTANT TH0:       $8D CONSTANT TH1:
$90 CONSTANT P1:        $98 CONSTANT SCON:
$99 CONSTANT SBUF:      $A8 CONSTANT IE:
$B0 CONSTANT P3:        $B8 CONSTANT IP:
$D0 CONSTANT PSW:       $E0 CONSTANT ACC:
$F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL

[THEN]


89C4051? [IF]

$81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $87 CONSTANT PCON:
$88 CONSTANT TCON:      $89 CONSTANT TMOD:
$8A CONSTANT TL0:       $8B CONSTANT TL1:
$8C CONSTANT TH0:       $8D CONSTANT TH1:
$90 CONSTANT P1:        $98 CONSTANT SCON:
$99 CONSTANT SBUF:      $A8 CONSTANT IE:
$B0 CONSTANT P3:        $B8 CONSTANT IP:
$D0 CONSTANT PSW:       $E0 CONSTANT ACC:
$F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL

[THEN]

89C51? [IF]

$80 CONSTANT P0:        $81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $87 CONSTANT PCON:      $88 CONSTANT TCON:
$89 CONSTANT TMOD:      $8A CONSTANT TL0:       $8B CONSTANT TL1:
$8C CONSTANT TH0:       $8D CONSTANT TH1:       $90 CONSTANT P1:
$98 CONSTANT SCON:      $99 CONSTANT SBUF:      $A0 CONSTANT P2:
$A8 CONSTANT IE:        $B0 CONSTANT P3:        $B8 CONSTANT IP:
$D0 CONSTANT PSW:       $E0 CONSTANT ACC:       $F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL

[THEN]

89C52? [IF]

$80 CONSTANT P0:        $81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $87 CONSTANT PCON:      $88 CONSTANT TCON:
$89 CONSTANT TMOD:      $8A CONSTANT TL0:       $8B CONSTANT TL1:
$8C CONSTANT TH0:       $8D CONSTANT TH1:       $90 CONSTANT P1:
$98 CONSTANT SCON:      $99 CONSTANT SBUF:      $A0 CONSTANT P2:
$A8 CONSTANT IE:        $B0 CONSTANT P3:        $B8 CONSTANT IP:
$C8 CONSTANT T2CON:     $C9 CONSTANT T2MOD:     $CA CONSTANT RCAP2L:
$CB CONSTANT RCAP2H:    $CC CONSTANT TL2:       $CD CONSTANT TH2:
$D0 CONSTANT PSW:       $E0 CONSTANT ACC:       $F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL
47. CPU-VECTOR TIMER2

[THEN]

89C55? [IF]

$80 CONSTANT P0:        $81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $87 CONSTANT PCON:      $88 CONSTANT TCON:
$89 CONSTANT TMOD:      $8A CONSTANT TL0:       $8B CONSTANT TL1:
$8C CONSTANT TH0:       $8D CONSTANT TH1:       $90 CONSTANT P1:
$98 CONSTANT SCON:      $99 CONSTANT SBUF:      $A0 CONSTANT P2:
$A8 CONSTANT IE:        $B0 CONSTANT P3:        $B8 CONSTANT IP:
$C8 CONSTANT T2CON:     $C9 CONSTANT T2MOD:     $CA CONSTANT RCAP2L:
$CB CONSTANT RCAP2H:    $CC CONSTANT TL2:       $CD CONSTANT TH2:
$D0 CONSTANT PSW:       $E0 CONSTANT ACC:       $F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL
47. CPU-VECTOR TIMER2

[THEN]

89S8252? [IF]

$80 CONSTANT P0:        $81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $82 CONSTANT DP0L:      $83 CONSTANT DP0H:
$84 CONSTANT DP1L:      $85 CONSTANT DP1H:      $86 CONSTANT SPDR:
$87 CONSTANT PCON:      $88 CONSTANT TCON:      $89 CONSTANT TMOD:
$8A CONSTANT TL0:       $8B CONSTANT TL1:       $8C CONSTANT TH0:
$8D CONSTANT TH1:       $90 CONSTANT P1:        $96 CONSTANT WMCON:
$98 CONSTANT SCON:      $99 CONSTANT SBUF:      $A0 CONSTANT P2:
$A8 CONSTANT IE:        $AA CONSTANT SPSR:      $B0 CONSTANT P3:
$B8 CONSTANT IP:        $C8 CONSTANT T2CON:     $C9 CONSTANT T2MOD:
$CA CONSTANT RCAP2L:    $CB CONSTANT RCAP2H:    $CC CONSTANT TL2:
$CD CONSTANT TH2:       $D0 CONSTANT PSW:       $D5 CONSTANT SPCR:
$E0 CONSTANT ACC:       $F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL
47. CPU-VECTOR TIMER2

[THEN]

89S53? [IF]

$80 CONSTANT P0:        $81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $82 CONSTANT DP0L:      $83 CONSTANT DP0H:
$84 CONSTANT DP1L:      $85 CONSTANT DP1H:      $86 CONSTANT SPDR:
$87 CONSTANT PCON:      $88 CONSTANT TCON:      $89 CONSTANT TMOD:
$8A CONSTANT TL0:       $8B CONSTANT TL1:       $8C CONSTANT TH0:
$8D CONSTANT TH1:       $90 CONSTANT P1:        $96 CONSTANT WCON:
$98 CONSTANT SCON:      $99 CONSTANT SBUF:      $A0 CONSTANT P2:
$A8 CONSTANT IE:        $AA CONSTANT SPSR:      $B0 CONSTANT P3:
$B8 CONSTANT IP:        $C8 CONSTANT T2CON:     $C9 CONSTANT T2MOD:
$CA CONSTANT RCAP2L:    $CB CONSTANT RCAP2H:    $CC CONSTANT TL2:
$CD CONSTANT TH2:       $D0 CONSTANT PSW:       $D5 CONSTANT SPCR:
$E0 CONSTANT ACC:       $F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL
47. CPU-VECTOR TIMER2

[THEN]

89S52? [IF]

$80 CONSTANT P0:        $81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $82 CONSTANT DP0L:      $83 CONSTANT DP0H:
$84 CONSTANT DP1L:      $85 CONSTANT DP1H:      $87 CONSTANT PCON:
$88 CONSTANT TCON:      $89 CONSTANT TMOD:      $8A CONSTANT TL0:
$8B CONSTANT TL1:       $8C CONSTANT TH0:       $8D CONSTANT TH1:
$8E CONSTANT AUXR:      $90 CONSTANT P1:        $98 CONSTANT SCON:
$99 CONSTANT SBUF:      $A0 CONSTANT P2:        $A2 CONSTANT AUXR1:
$A6 CONSTANT WDTRST:    $A8 CONSTANT IE:        $B0 CONSTANT P3:
$B8 CONSTANT IP:        $C8 CONSTANT T2CON:     $C9 CONSTANT T2MOD:
$CA CONSTANT RCAP2L:    $CB CONSTANT RCAP2H:    $CC CONSTANT TL2:
$CD CONSTANT TH2:       $D0 CONSTANT PSW:       $E0 CONSTANT ACC:
$F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL
47. CPU-VECTOR TIMER2

[THEN]


89S51? [IF]

$80 CONSTANT P0:        $81 CONSTANT SP:        $82 CONSTANT DPL:
$83 CONSTANT DPH:       $82 CONSTANT DP0L:      $83 CONSTANT DP0H:
$84 CONSTANT DP1L:      $85 CONSTANT DP1H:      $87 CONSTANT PCON:
$88 CONSTANT TCON:      $89 CONSTANT TMOD:      $8A CONSTANT TL0:
$8B CONSTANT TL1:       $8C CONSTANT TH0:       $8D CONSTANT TH1:
$8E CONSTANT AUXR:      $90 CONSTANT P1:
$98 CONSTANT SCON:      $99 CONSTANT SBUF:      $A0 CONSTANT P2:
$A2 CONSTANT AUXR1:     $A6 CONSTANT WDTRST:
$A6 CONSTANT IE:        $B0 CONSTANT P3:        $B8 CONSTANT IP:
$D0 CONSTANT PSW:       $E0 CONSTANT ACC:       $F0 CONSTANT B:  

 3. CPU-VECTOR EXTERN0
11. CPU-VECTOR TIMER0
19. CPU-VECTOR EXTERN1
27. CPU-VECTOR TIMER1
35. CPU-VECTOR SERIAL

[THEN]
                              ( Einde )
